unit hiStGrd;

interface

uses Kol,Share,Debug,KOLStGrd,Win;

type
  THIStGrd = class(THIWin)
   private
    Control2:PStGrd;
    Obj:PMatrix;
    SelCol:longint;
    SelRow:longint;
    SelStr:string;
    ScrlStyle:TScrollStyle;
    procedure SetCols(Col:string);
    procedure SetRows(Row:string);
    procedure _onSelectCell(Sender:PControl;ACol,ARow:longint;var CanSelect: Boolean);
    procedure _Set(x,y:integer; var Val:TData);
    function _Get(x,y:integer):TData;
   public

    //_prop_Ctl3d:boolean;
    _prop_ScrollBars:integer;
    _prop_SrollBars:integer;
    _prop_WidthCols:string;
    _prop_HeightRows:string;
    _prop_HasBrdr:boolean;
    _prop_DrawFocusSelected:boolean;
    _prop_RowSizing:boolean;
    _prop_ColSizing:boolean;
    _prop_RowMoving:boolean;
    _prop_ColMoving:boolean;
    _prop_RowSelect:boolean;
    _prop_RangeSelect:boolean;
    _prop_MultiSelect:boolean;
    _prop_TitleCols:integer;
    _prop_TitleRows:integer;

    _data_Row:THI_Event;
    _data_Col:THI_Event;
    _data_Str:THI_Event;

    _event_onSelect:THI_Event;


    constructor Create(Parent:PControl);
    procedure Init;override;
    procedure _work_doSet(var _Data:TData; Index:word);
    procedure _var_SelectedCol(var _Data:TData; Index:word);
    procedure _var_SelectedRow(var _Data:TData; Index:word);
    procedure _var_StrInSelected(var _Data:TData; Index:word);
    procedure _var_Matrix(var _Data:TData; Index:word);
  end;

implementation


constructor thistGrd.Create;
begin
  Inherited Create(Parent);
  Control2:=NewStGrd(Parent,1,1,1,1,110,110,[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine],true,true,true,ssNone);
  Control:=Control2;
end;

procedure THIStGrd.Init;
var tgo:TGridOptions;
begin
  Case _prop_ScrollBars of
    0:ScrlStyle:=ssNone;
    1:ScrlStyle:=ssHorizontal;
    2:ScrlStyle:=ssVertical;
    3:ScrlStyle:=ssBoth;
  end;
  SetCols(_prop_WidthCols);
  SetRows(_prop_HeightRows);
  Control2.FixedCols:=_prop_TitleCols;
  Control2.FixedRows:=_prop_Titlerows;
  Control2.ScrollBars:=ScrlStyle;
  //Control2.c3D:=_prop_Ctl3d;
  tgo := Control2.Options;
   if _prop_DrawFocusSelected then
     include(tgo,goDrawFocusSelected);
   if _prop_RowSizing then
     include(tgo,goRowSizing);
   if _prop_ColSizing then
     include(tgo,goColSizing);
   if _prop_RowMoving then
     include(tgo,goRowMoving);
   if _prop_ColMoving then
     include(tgo,goColMoving);
   if _prop_RowSelect then
     include(tgo,goRowSelect);
   if _prop_RangeSelect then
     include(tgo,goRangeSelect);
   if not _prop_MultiSelect then
     include(tgo,goEditing);
  Control2.Options := tgo;
  Inherited;
  Control2.OnSelectCell:=_onSelectCell;
end;

procedure THIStGrd.SetCols;
var lst:PStrList;
    i:word;
    s:string;
begin
   lst := NewStrList;
   lst.text := col;
   Control2.ColCount:=lst.count;
   if lst.Count > 0 then
    for i := 0 to lst.Count-1 do
     begin
       Control2.ColWidths[i]:=str2int(lst.items[i]);
     end;
   lst.Free;
end;

procedure THIStGrd.SetRows;
var lst:PStrList;
    i:word;
    s:string;
begin
   lst := NewStrList;
   lst.text := row;
   Control2.RowCount:=lst.count;
   if lst.Count > 0 then
    for i := 0 to lst.Count-1 do
     begin
       Control2.RowHeights[i]:=str2int(lst.items[i]);
     end;
   lst.Free;
end;

procedure THIStGrd._work_doSet;
begin
  Control2.Cells[ReadInteger(_Data,_data_Col,0),ReadInteger(_Data,_data_Row,0)] := ReadString(_Data,_data_Str,'');
end;

procedure THIStGrd._onSelectCell;
begin
  _hi_onEvent(_event_onSelect,Control2.Cells[ACol,ARow]);
  SelCol:=ACol;
  SelRow:=ARow;
  SelStr:=Control2.Cells[SelCol,SelRow];
end;

procedure THIStGrd._var_SelectedCol;
begin
  _Data.data_type:=data_int;
  _Data.idata:=SelCol;
end;

procedure THIStGrd._var_SelectedRow;
begin
  _Data.data_type:=data_int;
  _Data.idata:=SelRow;
end;

procedure THIStGrd._var_StrInSelected;
begin
  _Data.data_type:=data_str;
  _Data.sdata:=SelStr;
end;

procedure THIStGrd._var_Matrix;
begin
  if Obj = nil then begin
    new(Obj);
    Obj._Set := _Set;
    Obj._Get := _Get;
  end;
  _Data.Data_type := data_matr;
  _Data.idata := integer(Obj);
end;

function THIStGrd._Get;
begin
   if(x>=0)and(y>=0)and(y<Control2.ColCount)and(x<Control2.RowCount) then begin
     Result.Data_type := data_str;
     Result.sdata := Control2.Cells[y,x];
   end
   else Result.Data_type := data_null;
end;

procedure THIStGrd._Set;
begin
   if(x>=0)and(y>=0)and(y<Control2.ColCount)and(x<Control2.RowCount) then
     Control2.Cells[y,x] := ToString(Val);
end;

end.
